#include "present.h"
#include<vector>
int fenwick[350005];
void update(int num,int N)
{
    for(int i=num;i<=N;i+=(i & -i))
    {
        fenwick[i]++;
    }
}
int query(int num)
{
    int suma=0;
    for(int i=num;i>0;i-=(i & -i))
    {
        suma+=fenwick[i];
    }
    return suma;
}
std::vector < int > solve(int N)
{
    std::vector <int> a(N);

    int q,l,r,mid;

    for(int i=1;i<N;i++)
    {
        l=1;r=N;
        while(l<=r)
        {
            mid=(l+r)/2;
            if(query(mid)<question(mid,i))
                r=mid-1;
            else
                l=mid+1;
        }
        a[i]=l;
        update(q,N);
    }
    for(int i=1;i<=N;i++)
    {
        if(!fenwick[i])
        {
            a[N-1]=i;
            break;
        }
    }

    return a;
}
