#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

long long const MAXN=1200000;
long long n, k, used[MAXN], d[MAXN], inf = 1e9, a[MAXN], baned[MAXN];

struct edge
{
    long long ver, dist;
    edge(){};
    edge(long long vr, long long dt)
    {
        ver = vr;
        dist = dt;
    }
    bool operator<(const edge &ed)const
    {
        return dist > ed.dist;
    }
};

vector<edge> v[MAXN];

void dijkstra(long long s)
{
    for(long long i=1;i<=n;i++)
    {
        d[i] = inf;
    }
    d[s] = 0;
    edge e(s,0);
    priority_queue<edge> q;
    q.push(e);
    while(!q.empty())
    {
        edge u = q.top();
        q.pop();
        if(u.dist <= d[u.ver])
        {
            if(!used[u.ver])
            {
                used[u.ver] = 1;
                long long sz = v[u.ver].size();
                for(long long i=0;i<sz;i++)
                {
                    edge nb = v[u.ver][i];
                    if(nb.dist + u.dist < d[nb.ver])
                    {
                        nb.dist = nb.dist + u.dist;
                        d[nb.ver] = nb.dist;
                        q.push(nb);
                    }
                }
            }
        }
    }
}

void read()
{
    long long x, y, t;
    cin>>n>>k;
    for(long long i=1;i<n;i++)
    {
        cin>>x>>y>>t;
        v[x].push_back({y,t});
        v[y].push_back({x,t});
    }
    for(long long i=1;i<=k;i++)
    {
        cin>>a[i];
    }
    for(long long i=1;i<=n;i++)
    {
        long long ans = 0;
        memset(used, 0, sizeof(used));
        dijkstra(i);
        baned[i] = 1;
        for(long long u=1;u<=k;u++)
        {
            long long minn = 1e9, pos;
            for(long long j=1;j<=k;j++)
            {
                if(!baned[a[j]] && minn > d[a[j]])
                {
                    minn = d[a[j]];
                    pos = j;
                }
            }
            if(minn == 1e9) minn = 0;
            ans += minn;
            baned[a[pos]] = 1;
            memset(used, 0, sizeof(used));
            dijkstra(a[pos]);
        }
        memset(baned, 0, sizeof(baned));
        cout<<ans<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
