#include<bits/stdc++.h>
using namespace std;
const int maxn = 1024;
struct edge
{
    int to;
    int p;
    edge() {};
    edge( int to1, int p1 )
    {
        to = to1;
        p = p1;
    }
};
int n,k;
vector<edge>v[maxn];
int used[maxn];
int is_k[maxn];
int dist[maxn][maxn];
vector<int>c;
void read()
{
    cin >> n >> k;
    for( int i = 1; i < n; i ++ )
    {
        int x,y,z;
        cin >> x >> y >> z;
        edge e1(x,z);
        edge e2(y,z);
        v[y].push_back(e1);
        v[x].push_back(e2);
    }
    for( int i = 1; i <= k; i ++ )
    {
        int x;
        cin >> x;
        is_k[x] = 1;
        c.push_back(x);
    }
}
int start;
void dfs( int w )
{
    used[w] = 1;
    int sz = v[w].size();
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i].to;
        if( used[nb] == 0 )
        {
            dist[start][nb] = dist[start][w] + v[w][i].p;
            dfs(nb);
        }
    }
}
int perm[maxn];
int cnt;
int ans = 10000000;
void check( int pos )
{
    if( pos > cnt )
    {
        //for( int i = 1; i <= cnt; i ++ )
           // cout << perm[i] << " ";
        //cout << endl;
        int tans = 0;
        for( int i = 1; i < cnt; i ++ )
        {
            int x = perm[i];
            int y = perm[i+1];
            tans += dist[x][y];
        }
        if( tans < ans ) ans = tans;
        return;
    }
    int sz = c.size();
    for( int i = 0; i < sz; i ++ )
    {
        int nb = c[i];
        if( used[nb] == 0 )
        {
            used[nb] = 1;
            perm[pos] = nb;
            check(pos+1);
            used[nb] = 0;
        }
    }
}
void solve()
{
    for( int i = 1; i <= n; i ++ )
    {
        perm[1] = i;
        used[i] = 1;
        cnt = k + 1;
        if( is_k[i] == 1 ) cnt -= 1;
        check(2);
        cout << ans << endl;
        ans = 10000000;
        used[i] = 0;
    }
}
int main()
{
    read();
    for( int i = 1; i <= n; i ++ )
    {
        start = i;
        dfs(i);
        memset(used,0,sizeof(used));
    }
    //cout << 111 << endl;
    solve();
    return 0;
}
