#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

long long const MAXN=1000;
long long n, k, m[MAXN][MAXN], p[MAXN], used[MAXN], a[MAXN], ans = 1e18;


struct edge
{
    long long ver, dist;
};

vector<edge> v[MAXN];

void DFS(long long i, long long start)
{
    used[i] = 1;
    long long sz = v[i].size();
    for(long long j=0;j<sz;j++)
    {
        edge nb = v[i][j];
        if(!used[nb.ver])
        {
            m[start][nb.ver] = m[start][i] + nb.dist;
            used[nb.ver] = 1;
            DFS(nb.ver, start);
        }
    }
}

void print()
{
    for(int i=1;i<=k;i++)
    {
        cout<<p[i]<<" ";
    }
    cout<<endl;
}

void perm(long long pos, long long start)
{
    if(pos>k)
    {
        //print();
        long long last = start, cnt=0;
        for(long long i=1;i<=n;i++)
        {
            long long idx = p[i];
            cnt += m[last][a[idx]];
            last = a[idx];
        }
        if(ans > cnt) ans = cnt;
    }
    else
    {
        for(long long i=1;i<=k;i++)
        {
            if(!used[i])
            {
                used[i] = 1;
                p[pos] = i;
                perm(pos+1, start);
                used[i] = 0;
            }
        }
    }
}

void read()
{
    long long x, y, t;
    cin>>n>>k;
    for(long long i=1;i<n;i++)
    {
        cin>>x>>y>>t;
        v[x].push_back({y,t});
        v[y].push_back({x,t});
    }
    for(long long i=1;i<=n;i++)
    {
        DFS(i,i);
        memset(used, 0, sizeof(used));
    }
    for(long long i=1;i<=k;i++)
    {
        cin>>a[i];
    }
    for(long long i=1;i<=n;i++)
    {
        ans = 1e18;
        perm(1,i);
        memset(p,0,sizeof(p));
        cout<<ans<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
