#include<bits/stdc++.h>
using namespace std;
const int maxn = 1024;
struct edge
{
    int to;
    int p;
    edge() {};
    edge( int to1, int p1 )
    {
        to = to1;
        p = p1;
    }
};
int n,k;
vector<edge>v[maxn];
int used[maxn];
int is_k[maxn];
int dist[maxn][maxn];
int dist1[maxn][maxn];
vector<int>c;
void read()
{
    cin >> n >> k;
    for( int i = 1; i < n; i ++ )
    {
        int x,y,z;
        cin >> x >> y >> z;
        edge e1(x,z);
        edge e2(y,z);
        v[y].push_back(e1);
        v[x].push_back(e2);
    }
    for( int i = 1; i <= k; i ++ )
    {
        int x;
        cin >> x;
        is_k[x] = 1;
        c.push_back(x);
    }
}
int start;
void dfs( int w )
{
    used[w] = 1;
    int sz = v[w].size();
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i].to;
        if( used[nb] == 0 )
        {
            dist[start][nb] = dist[start][w] + v[w][i].p;
            dist1[start][nb] = dist1[start][w] + 1;
            dfs(nb);
        }
    }
}
void check( int w )
{
    used[w] = 1;
    int ans = 0;
    int cnt = k;
    if( is_k[w] == 1 ) cnt -= 1;
    for( int i = 1; i <= cnt; i ++ )
    {
        int mt = -1;
        int sz = c.size();
        for( int j = 0; j < sz; j ++ )
        {
            int nb = c[j];
            if( used[nb] == 0 && nb != w )
            {
                if( mt == -1 ) mt = nb;
                else if( dist[w][nb] < dist[w][mt] ) mt = nb;
                else if( dist[w][nb] == dist[w][mt] && dist1[w][nb] < dist1[w][mt] ) mt = nb;
            }
        }
        //cout << w << " " << mt << endl;
        used[mt] = 1;
        ans += dist[w][mt];
        w = mt;
    }
    cout << ans << endl;
    memset(used,0,sizeof(used));
}
void solve()
{
    for( int i = 1; i <= n; i ++ )
    {
        check(i);
    }
}
int main()
{
    read();
    for( int i = 1; i <= n; i ++ )
    {
        start = i;
        dfs(i);
        memset(used,0,sizeof(used));
    }
    //cout << 111 << endl;
    solve();
    return 0;
}
